package com.smith9.geiger.client.beans

import org.joda.time.DateTime
import simplygroovy.bean.Period

import org.apache.commons.beanutils.BeanUtils
import simplygroovy.util.DateUtil
/**
 * Created: Mar 17, 2011
 * @author david
 */
class Count implements Stat {
    boolean isLevelled = false
    public static final String FORMAT = "dd/MM/yyyy hh.mm.ss.SSS"
    DateTime periodStart
    Period period
    String category
    String subCategory
    String productName
    String environment
    String subProduct
    boolean failure = false
    String key
    static Collection<MetaProperty> SETTERS = Count.metaClass.getProperties().findAll() {it.getSetter() != null}


    void setPeriodStart(DateTime periodStart) {
        this.periodStart = periodStart
        key = null
    }

    void setPeriod(Period period) {
        this.period = period
        key = null
    }

    void setCategory(String category) {
        this.category = category
        key = null
    }

    void setSubCategory(String subCategory) {
        this.subCategory = subCategory
        key = null
    }

    void setProductName(String productName) {
        this.productName = productName
        key = null
    }

    void setEnvironment(String environment) {
        this.environment = environment
        key = null
    }

    void setSubProduct(String subProduct) {
        this.subProduct = subProduct
        key = null
    }

    void setFailure(boolean failure) {
        this.failure = failure
        key = null
    }

    int count = 0
    Double min
    Double max
    Double sum

    public String toString ( ) {
    return "Count{" +
    "environment='" + environment + '\'' +
    ", product='" + productName + '\'' +
    ", subProduct='" + subProduct + '\'' +
    ", periodStart=" + periodStart +
    ", failure=" + failure +
    ", period=" + period +
    ", category=" + category +
    ", subCategory=" + subCategory +
    ", count=" + count +
    ", min=" + min +
    ", max=" + max +
    ", sum=" + sum +
    '}' ;
    }

    public void validate() {
        if(!period) {
            throw new IllegalStateException("Period must be set")
        }
        if(!category) {
            throw new IllegalStateException("Category must be set")
        }
        if(!periodStart) {
            throw new IllegalStateException("Period Start must be set")
        }
        if(!productName) {
            throw new IllegalStateException("Product Name must be set")
        }
    }
    public String getKey() {
        if(!key) {
            key = ([environment, productName, subProduct, period, category, subCategory, failure, periodStart.toString(FORMAT)]).join(':')
        }
        return key

    }
    public void merge(Count addCount) {
        count += addCount.count
        min = ([min, addCount.min] - null).min()
        max = ([max, addCount.max] - null).max()
        sum = ([sum, addCount.sum] - null).sum()
    }

    Count createCopyLevelDate() {
        Count copy = createCopy()
        levelDate(copy)
        return copy
    }

    private Count createCopy() {
        // TODO work out which is faster...
//        Count clone = BeanUtils.cloneBean(this) as Count
        Count clone = SETTERS.inject(new Count()){count,metaProp->
            metaProp.setProperty(count,metaProp.getProperty(this))
            count
        }
        return clone
    }

    Count createCopyLevelDate(Period period) {
        Count copy = createCopy()
        copy.period = period
        levelDate(copy)
        return copy
    }
    public static void levelDate(Count count) {
        count.periodStart = DateUtil.level(count.periodStart, count.period)
        count.isLevelled = true
    }
}